#version 130

out vec4 outcolor;
in vec2 fTexCoord;

uniform int level;
uniform sampler2D data;

void main()
{
    ivec2 coord0 = ivec2(gl_FragCoord.xy) * 2; 
    ivec2 coord1 = coord0 + ivec2(1, 1);
    ivec2 coord2 = coord0 + ivec2(1, 0);
    ivec2 coord3 = coord0 + ivec2(0, 1);

    vec4 d0 = texelFetch(data, coord0, level - 1); 
    vec4 d1 = texelFetch(data, coord1, level - 1); 
    vec4 d2 = texelFetch(data, coord2, level - 1); 
    vec4 d3 = texelFetch(data, coord3, level - 1); 

    float min0 = min(d0.x,min(d0.y,min(d0.z,d0.w)));
    float min1 = min(d1.x,min(d1.y,min(d1.z,d1.w)));
    float min2 = min(d2.x,min(d2.y,min(d2.z,d2.w)));
    float min3 = min(d3.x,min(d3.y,min(d3.z,d3.w)));

    float smallest = min(min(min(min0,min1),min2),min3);
    
    outcolor = vec4(smallest,smallest,smallest,smallest);   
}
